//
//  EdgeGlowVertex.glsl
//  Magic Globe
//
//  Created by joeld on 1/20/12.
//  Copyright 2012 Smule. All rights reserved.
//

attribute vec3 position;
attribute vec2 st;
attribute vec4 color;

varying lowp vec4 colorVarying;
varying mediump vec2 stVarying;
varying highp vec3 posVarying;

uniform highp vec3 sunDir;

uniform mat4 modelViewProjectionMatrix;
//uniform mat3 normalMatrix;

void main()
{
    vec3 posN = normalize( position );

    posVarying = position;
    
    // compute day/night value the same way as the globe shader
    const float kBlendSpread = 0.5;
    highp float dayNightVal = dot( sunDir, posN );
    
    // st s = day/night value, t unmodified (vertical texture coord)
    stVarying = vec2( smoothstep( -kBlendSpread,kBlendSpread, dayNightVal ), st.t );
    
    gl_Position = modelViewProjectionMatrix * vec4( position.x, position.y, position.z, 1.0 );

}
