//
//  GlobeVertex.glsl
//  Magic Globe
//
//  Created by joeld on 1/10/12.
//  Copyright 2012 Smule. All rights reserved.
//

attribute vec3 position;
attribute vec2 st;
//attribute vec3 normal;

varying lowp vec4 atmoGlow; // atmosphere glow color

varying mediump vec2 stVarying;
varying highp vec3 posVarying;

// "backlight" glow .. adjust where the backglow wraps
uniform vec2 atmoMix;

// projection
uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewProjectionInverseMatrix;
//uniform mat3 normalMatrix;

// atmosphere colors (ADD)
uniform vec3 atmoColor0; // horizon
uniform vec3 atmoColor1; // middle
uniform vec3 atmoColor2; // center

void main()
{
//    vec3 eyeNormal = normalize(normalMatrix * normal);
    vec3 eyeNormal = normalize( position );
    
    vec3 lightPosition = vec3(0.0, 0.0, 1.0);
    vec4 diffuseColor = vec4(0.4, 0.4, 1.0, 1.0);
    
    posVarying = position;
    
    // Atmosphere glow color -- fresnel backlight
    vec4 viewDir = vec4( 0.0, 0.0, -1.0, 0.0 );
    viewDir = modelViewProjectionInverseMatrix * viewDir;
    float nDotVP = abs(dot(eyeNormal, viewDir.xyz) ); 
    
    atmoGlow.a = 1.0;
    
//    const float midVal = 0.5;
    vec3 atmoColorTop = mix( atmoColor0, atmoColor1, smoothstep( atmoMix.x, atmoMix.y, nDotVP ));
    vec3 atmoColorBottom = mix( atmoColor1, atmoColor2, smoothstep( atmoMix.y, 1.0, nDotVP ));     
    atmoGlow.rgb = mix( atmoColorTop, atmoColorBottom, step( atmoMix.y, nDotVP ) );
    
    // DBG
//    atmoGlow.rgb = atmoColorTop;
    
//    atmoGlow.rgb = vec3( nDotVP, nDotVP, nDotVP );
    
//    atmoGlow = diffuseColor * nDotVP;
//    atmoGlow = vec4( viewDir.x, viewDir.y, viewDir.z, 1.0 );
//    atmoGlow = vec4( 1.0, 0.0, 1.0, 1.0 );
    
    stVarying = st;
//    colorVarying = vec4(0.4, 0.4, 1.0, 1.0);
    
    gl_Position = modelViewProjectionMatrix * vec4( position.x, position.y, position.z, 1.0 );
//    gl_Position = vec4( position.x, position.y, position.z, 1.0 );
}
